# the following line first
from merescocomponents.facetindex.merescolucene import IndexWriter, Term, merescoStandardAnalyzer
from java.lang.reflect import Array
from java.lang import Object
from org.apache.lucene.store import Directory, FSDirectory
from merescocomponents.facetindex.tools.lucenetools import unlock
from sys import argv
from os import open, O_RDONLY, O_CREAT
from os.path import basename, join as join_path

args = argv[1:]
if len(args) < 2:
    print "Usage: %s <empty reader database directory> <directories of writer databases>" % basename(argv[0])
else:
    readerDatabase = args[0]

    lockFile = join_path(readerDatabase, 'lock')
    fd = open(lockFile, O_RDONLY|O_CREAT)
    flock(fd, LOCK_EX|LOCK_NB)

    readerIndex = join_path(readerDatabase, 'index')
    unlock(readerIndex)

    # new (empty) index will be created, replacing the index already there, if any
    indexWriter = IndexWriter(readerIndex, merescoStandardAnalyzer, True)

    writerDatabases = args[1:]
    length = len(writerDatabases)

    dirArray = Array.newInstance(Directory, length) 
    count = 0

    for writerDatabase in writerDatabases:
        lockFile = join_path(writerDatabase, 'lock')
        fd = open(lockFile, O_RDONLY|O_CREAT)
        flock(fd, LOCK_EX|LOCK_NB)

        writerIndex = join_path(writerDatabase, 'index')
        indexDir = FSDirectory.getDirectory(writerIndex) % Directory
        Array.set(dirArray % Object, count, indexDir % Object)

        print count++

    indexWriter.addIndexesNoOptimize(dirArray)
    indexWriter.close()
